const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const components = sequelize.define(
    'components',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

name: {
        type: DataTypes.TEXT,
      
      

      },

component_type: {
        type: DataTypes.ENUM,
      
      

        values: [

"primitive",


"composite",


"layout"

        ],

      },

props: {
        type: DataTypes.TEXT,
      
      

      },

is_public: {
        type: DataTypes.BOOLEAN,
      
        allowNull: false,
        defaultValue: false,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  components.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity
















//end loop



    db.components.belongsTo(db.users, {
      as: 'owner',
      foreignKey: {
        name: 'ownerId',
      },
      constraints: false,
    });

    db.components.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });



    db.components.hasMany(db.file, {
      as: 'preview',
      foreignKey: 'belongsToId',
      constraints: false,
      scope: {
        belongsTo: db.components.getTableName(),
        belongsToColumn: 'preview',
      },
    });


    db.components.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.components.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return components;
};


